(function ($) {

  BBExcerpt = {

    _cbVal: [],
    _preview: [],

    /**
     * Initializes the events.
     *
     * @since 1.0
     * @access private
     * @method _init
     */
    _init: function () {
      BBExcerpt._bindEvents();
    },

    /**
     * Binds the events to fields.
     *
     * @since 1.0
     * @access private
     * @method _bindEvents
     */
    _bindEvents: function () {
      $('body').delegate('.fl-builder-bar-actions .fl-builder-excerpt-button', 'click', BBExcerpt._openExcerptPanelClicked);
      $('body').delegate('.fl-builder-excerpt-settings .fl-builder-settings-save', 'click', BBExcerpt._saveExcerptPanelClicked);
    },

    _openExcerptPanelClicked: function () {
      FLBuilderSettingsForms.render( {
        id        : 'bb_excerpt_form',
        className : 'fl-builder-excerpt-settings',
        settings  : FLBuilderConfig.excerpt
      });
    },

    _saveExcerptPanelClicked: function (){
      var form     = $(this).closest('.fl-builder-settings'),
        valid    = form.validate().form(),
        settings = FLBuilder._getSettings( form );

      if(valid) {

        FLBuilder.showAjaxLoader();

        FLBuilder.ajax({
          action: 'save_excerpt_settings',
          settings: settings
        }, BBExcerpt._saveExcerptPanelComplete);

        FLBuilder._lightbox.close();
      }
    },

    _saveExcerptPanelComplete: function( response )
    {
      FLBuilderConfig.excerpt = JSON.parse( response );
      FLBuilder._updateLayout();
    },
  };

  BBExcerpt._init();

})(jQuery);
